program Import;

Uses
 Palette,Sprites;

Type
 BMP256=Record

  bfType:array[1..2] of char;
  bfSize:LongInt;
  brReserved:LongInt;
  bgOffBits:LongInt;

  biSize:LongInt;
  biWidth:LongInt;
  biHeight:LongInt;
  biPlanes:word;
  biBitCount:word;
  biCompression:longint;
  biSizeImage:longint;
  biXPelsPerMeter:longint;
  biYPelsPerMeter:longint;
  biClrUsed:Longint;
  biClrImportant:longint;

  WinPal:array[0..255,0..3] of byte;

 end;


procedure LoadBitmap;
 Var
  f:file;
  Header:BMP256;
  x,y:integer;
  line:array[0..319] of byte;
  Remap:array[0..255] of byte;

  function MapColor(color:byte):byte;
   var
    r1,g1,b1:integer;
    r2,g2,b2:integer;
    delta,best:longint;
    i:integer;
   begin
    r1:=Header.WinPal[color,2] shr 2;
    g1:=Header.WinPal[color,1] shr 2;
    b1:=Header.WinPal[color,0] shr 2;
    best:=3*64*64;
    MapColor:=255;
    for i:=0 to 255 do begin
     r2:=r1-colors[i,0];
     g2:=g1-colors[i,1];
     b2:=b1-colors[i,2];
     delta:=r2*r2+g2*g2+b2*b2;
     if delta<best then begin
      MapColor:=i;
      if delta=0 then exit;
      best:=delta;
     end;
    end;
   end;

 begin
  Assign(f,'SPRITES.BMP');
  Reset(f,1);
  BlockRead(f,Header,SizeOf(Header));
  if Header.bfType<>'BM' then halt;
  if Header.bfSize<>320*200+SizeOf(Header) then halt;
(*
  for x:=0 to 255 do begin
   Header.WinPal[x,0]:=Colors[x,2] shl 2;
   Header.WinPal[x,1]:=Colors[x,1] shl 2;
   Header.WinPal[x,2]:=Colors[x,0] shl 2;
   Header.WinPal[x,3]:=0;
  end;
*)
  for x:=0 to 255 do Remap[x]:=MapColor(x);

  for y:=199 downto 0 do begin
   BlockRead(f,Line,SizeOf(Line));
   for x:=0 to 319 do Mem[SegA000+20*y:x]:=Remap[Line[x]];
  end;
  Close(f);
 end;

var
 s:integer;
 x,y:integer;

begin
 asm mov ax,13h; int 10h end;
 SetupColors;

 LoadBitmap;

 s:=1;
 for y:=0 to 10 do
  for x:=0 to 19 do begin
   Snap(16*x,16*y,16,16,s);
   inc(s);
  end;

 SavespriteLib('SPRITELI.DAT');

 asm mov ax,03h; int 10h end;
end.

