Unit Font;

(*
Copyright (C) 1996-98  Paul Toth (tothpaul@mygale.org)

http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*)
Interface

Const
 Black         =0;
 Blue          =1;
 Green         =2;
 Cyan          =3;
 Red           =4;
 Magenta       =5;
 Brown         =6;
 LightGray     =7;
 DarkGray      =8;
 LightBlue     =9;
 LightGreen    =10;
 LightCyan     =11;
 LightRed      =12;
 LightMagenta  =13;
 Yellow        =14;
 White         =15;
 None          =255;

Var
 TextColor,TextBackground:byte;

Const
 VideoSeg:word=$A000;

function  OutTextXY(x,y:integer;str:string):integer;
function  TextWidth(str:string):integer;

Implementation

{$I FONT7x5}


function OutTextXY(X,Y:integer;Str:string):integer; assembler;
 asm
 { set es:di to first pixel }
  mov di,x
 { prevent nul string }
  les si,Str
  xor ch,ch
  mov cl,es:[si]
   or cl,cl
  jz  @Done
  mov dx,es
  inc si
 { compute Video Segment for line y = $A000+20*y }
  mov ax,y
  mov bx,20
  mul bl
  add ax,VideoSeg
  mov es,ax
 { set colors }
 @NextChar:
 { Get Char }
  push ds
   mov ds,dx
   lodsb
  pop ds
 { Get Font7x5[Char] }
  mov bx,Offset Font7x5
  xor ah,ah
  shl ax,3
  add bx,ax
 { Print Char }
  push es
   Call Near Ptr @PrintChar { return char width }
   add di,ax
  pop  es
 { NextChar }
 loop @NextChar

 jmp @done

 { Print Char : }
 @PrintChar:
 @NextLine:
  push di
 { Get First line }
  mov ah,[bx]
 { Get First bit  }
  shr ah,1
  jnc @DoBack { bit=0 }
  @DoText:
   mov al,TextColor
  @TextColor:
   stosb
   shr ah,1     { next bit }
  jc @TextColor { until bit=0 }
  @DoBack:
   mov al,TextBackground
  @BackColor:
   cmp al,None
   je  @Transparent
    mov es:[di],al
   @Transparent:
   inc di
   shr ah,1      { next bit }
  jnc @BackColor { until bit=1 }
   or  ah,ah    { bit left ? }
  jnz @DoText   { until end of line }
  { NextLine  }
   pop di       { restaure X pos }
   mov ax,es    { go down 1 line : Inc(VideoSeg,20) }
   add ax,20
   mov es,ax
   inc bx       { next char }
   mov al,[bx]
   cmp al,128   { stop bit ? }
   jb @NextLine { until stop }
   and ax,7Fh   { clear stop bit }
   retn         { return CharWidth }

  @Done:
   mov ax,di { return new X  }
   sub ax,x
 end;

function TextWidth(Str:string):integer; assembler;
 asm
 { default width=0 }
  xor ax,ax
 { get source string }
  les di,Str
 { prevent nul string }
  mov cl,es:[di]
  or  cl,cl
  jz  @Done
 @NextChar:
  inc di
 { Get Char }
  mov dl,[es:di]
 { Get Font7x5[Char] }
  mov bx,Offset Font7x5
  mov dh,0
  shl dx,3
  add bx,dx
 { Get Char Width }
  mov dx,[bx+7]
  and dx,7Fh
  add ax,dx
 { NextChar }
 loop @NextChar
  @Done:
 end;
end.

