Program Game;

Uses
 GameKit,Font,Sprites,Player,Palette;

{$DEFINE JOYSTICK}

Const
 First   = 1;
 Gandalf = 13;

Var
 f:file;

 Characters:array[1..4] of TCharacter;
 SortChars :array[1..4] of byte;
 CharCount :byte;
 x,y:integer;

 WorldX,WorldY:Integer;

Type
 TPlayer=object(TCharacter)
  procedure move; virtual;
 end;

 TTwin=object(TCharacter)
  procedure move; virtual;
 end;


Procedure TPlayer.Move;
 begin
   if keyboard[key_down] {$IFDEF JOYSTICK} or JoyDown {$ENDIF} then dy:=+1;
   if keyboard[key_left] {$IFDEF JOYSTICK} or JoyLeft {$ENDIF} then dx:=-1;
   if keyboard[key_up]   {$IFDEF JOYSTICK} or JoyUp   {$ENDIF} then dy:=-1;
   if keyboard[key_right]{$IFDEF JOYSTICK} or JoyRight{$ENDIF} then dx:=+1;

   { The Weapon }
   if keyboard[key_ctrl] {$IFDEF JOYSTICK} or JoyA    {$ENDIF} then

    If CharCount<4 then begin
     Characters[4].cx:=cx;
     Characters[4].cy:=cy;
     With Characters[4] do begin
      wx:=WorldX;
      wy:=WorldY;
      Sprite:=25;
      Direct:=0;
      Walk  :=0;
      dx    :=0;
      dy    :=0;
      Case Characters[1].Direct of
       0: dy:=+2*Step;
       1: dx:=-2*Step;
       2: dy:=-2*Step;
       3: dx:=+2*Step;
      end;
      Speak:='';
      MoveIt(dx,dy);
     end;
     CharCount:=4;
    end;

    if CharCount>3 then
     With Characters[4] do
      if MoveIt(dx,dy) then begin
      if (cx div 16=Characters[1].cx div 16)and(cy div 16=Characters[1].cy div 16) then
       CharCount:=3;
       if (wx<>WorldX)or(wy<>WorldY) then
        CharCount:=3
       else
        Walk:=Succ(Walk) and 3;
      end else begin
       if (cx div 16=Characters[1].cx div 16)and(cy div 16=Characters[1].cy div 16) then
        CharCount:=3
       else begin
        dx:=-dx;
        dy:=-dy;
       end;
     end;
  movesprite;
 end;


  { Twin Move }
Procedure TTwin.move;
 begin
  case direct of
   0:
    if moveit(-Step,0) then direct:=1 else
    if moveit(0,+Step) then direct:=0 else
    if moveit(+Step,0) then direct:=3 else
    if moveit(0,-Step) then direct:=2;
   1:
    if moveit(0,-Step) then direct:=2 else
    if moveit(-Step,0) then direct:=1 else
    if moveit(0,+Step) then direct:=0 else
    if moveit(+Step,0) then direct:=3;
   2:
    if moveit(+Step,0) then direct:=3 else
    if moveit(0,-Step) then direct:=2 else
    if moveit(-Step,0) then direct:=1 else
    if moveit(0,+Step) then direct:=0;
   3:
    if moveit(0,+Step) then direct:=0 else
    if moveit(+Step,0) then direct:=3 else
    if moveit(0,-Step) then direct:=2 else
    if moveit(-Step,0) then direct:=1;
  end;
   walk:=succ(walk) and 3;
 end;



Procedure QuickSort(L,R:integer);
 var
  i,j,v,t:integer;
 begin
  i:=L; j:=R;
  v:=Characters[(i+j) div 2].my;
  repeat
   while Characters[i].my<v do inc(i);
   while Characters[j].my>v do dec(j);
   if i<=j then begin
    if Characters[i].my<>Characters[j].my then begin
                    t:=Characters[i].my;
     Characters[i].my:=Characters[j].my;
     Characters[j].my:=t;
     t:=SortChars[i]; SortChars[i]:=SortChars[j]; SortChars[j]:=t;
    end;
    inc(i);
    dec(j);
   end;
  until i>j;
  if L<j then QuickSort(L,j);
  if i>R then QuickSort(i,R);
 end;

procedure Say(x,y,c:integer;s:string);
 var
  tw:integer;
 begin
  tw:=TextWidth(s);
  dec(x,tw div 2 - 8);
  dec(y,5);
  if x < Left then x:=Left;
  if x+tw > 13*16+Left then x:=13*16+Left-tw;
  if y < Top then y:=Top;

  TextColor:=DarkGray;
  OutTextXY(x-1,y-1,s);
  OutTextXY(x+1,y-1,s);
  OutTextXY(x-1,y+1,s);
  OutTextXY(x+1,y+1,s);

  TextColor:=Black;
  OutTextXY(x-1,y,s);
  OutTextXY(x+1,y,s);
  OutTextXY(x,y-1,s);
  OutTextXY(x,y+1,s);

  TextColor:=c;
  OutTextXY(x,y,s);
 end;

Procedure DrawSprites;
 var
  sp:byte;
 begin
  for sp:=1 to CharCount do SortChars[sp]:=sp;
  QuickSort(1,CharCount);

  For sp:=1 to CharCount do begin
   with Characters[SortChars[sp]] do begin
   { mx:=wx*13*16+cx; }
    my:=wy*11*16+cy;
    if (wx=WorldX)and(wy=WorldY) then begin
     DrawSprite(Sprite+3*Direct+abs(Walk-1),cx,cy);
     if Speak<>'' then begin
      if Scroll<Length(Speak) then inc(Scroll);
      Say(cx,cy,color,Copy(Speak,1,Scroll));
     end;
    end;
   end;
  end;

 end;


begin
 assign(f,'EDITOR.DAT');
 reset(f,1);
  blockread(f,Gamekit.Palette,SizeOf(Gamekit.Palette));
  blockread(f,Tiles^,SizeOf(TSprites));
  blockread(f,World^,SizeOf(TWorld));
{  blockread(f,Sprites^,SizeOf(TSprites)); }
 close(f);

 LoadSpriteLib('SPRITELIB.DAT');
 SpriteHook:=Ptr(Seg(SwapScreen^),Ofs(SwapScreen^)+TopLeft);

{$IFDEF JOYSTICK}
 InitJoyStick;
{$ENDIF}
 InitGameKit;
 InitGraphic;
 Palette.SetupColors;

 { The Hero }
 TPlayer(Characters[1]).Create(First,{0,11}13,0,32,16);
 with Characters[1] do begin
  Speak:='The Hero';
  Color:=Green;
 end;

 { Gandalf }
 with Characters[2] do begin
  Create(Gandalf,13,0,5*16,2*16);
  Speak:='Gandalf';
  Color:=LightBlue;
  Pattern:='40-"grrr"10-5r"well..."20-"Nothing here..."25-""4dr10-"Got it !"20-""5l4urd"I''m to old for this job !"';
 end;

 { Twin }
 TTwin(Characters[3]).Create(First,0,0,16,16);
 with Characters[3] do begin
  Speak:='Twin';
  Color:=Magenta;
 end;

 { Weapon }
 with Characters[4] do begin
  Create(250,0,0,0,0);
  Speak:='fweee';
  Color:=yellow;
 end;

 TextBackground:=None;
 VideoSeg:=Seg(SwapScreen^);

 CharCount:=3;

 WorldX:=-1;

 Repeat

  if (WorldX<>Characters[1].wx)
  or (WorldY<>Characters[1].wy) then begin
   WorldX:=Characters[1].wx;
   WorldY:=Characters[1].wy;
   BuildBackGround(WorldX,WorldY);
  end;

  RestoreBackground;
  DrawSprites;
  ShowScreen;

 {$ifdef joystick}
  ReadJoyStick;
 {$endif}
 { Move }
  for x:=1 to 3 do Characters[x].move;

  repeat until delay>3; delay:=0;

 until keyboard[key_esc] {$IFDEF JOYSTICK} or JoyB {$ENDIF};

 { DoneGameKit; { is set as ExitProc by InitGameKit }

end.