Unit Player;
(*
Copyright (C) 1996-98  Paul Toth (tothpaul@mygale.org)

http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*)

Interface

uses
 GameKit,Font;

Const
 Step    = 4;

Type
 TCharacter=object
  Sprite:integer;
  Direct:integer;
  Walk  :integer;
  wx,wy :integer;
  cx,cy :integer;
 { mx,}my :integer;
  dx,dy :integer;
  Speak :string;
  Scroll:byte;
  Color :byte;
  Pattern:string;
  PatPos :byte;
  PatDup :byte;
  constructor create(ASprite,awx,awy,ax,ay:integer);
  procedure move; virtual;
  procedure movesprite;
  function  moveit(ix,iy:integer):boolean;
 end;

Implementation

constructor TCharacter.Create(ASprite,awx,awy,ax,ay:integer);
 begin
  wx:=awx;
  wy:=awy;
  cx:=ax;
  cy:=ay;
  Sprite:=ASprite;
  Direct:=0;
  Walk:=0;
  my:=wx+cx;
  dx:=0;
  dy:=0;
  Speak:='';
  Scroll:=0;
  Color:=white;
  Pattern:='';
  PatPos:=0;
  PatDup:=0;
 end;

procedure TCharacter.move;
  procedure GetDup;
   begin
    PatDup:=0;
    repeat
     PatDup:=10*PatDup+Ord(Pattern[PatPos])-ord('0');
     inc(PatPos);
    until not (Pattern[PatPos] in ['0'..'9']);
   end;

  procedure GetSpeak;
   begin
    Speak:='';
    inc(PatPos);
    Scroll:=0;
    while Pattern[PatPos]<>'"' do begin
     Speak:=Speak+Pattern[PatPos];
     inc(PatPos);
    end;
   end;

 begin
  if (dx=0)and(dy=0) then begin
   if PatPos=Length(Pattern) then {Pattern:=''} PatPos:=0;
   if Pattern<>'' then begin
    if PatDup=0 then begin
     Inc(PatPos);
     case Pattern[PatPos] of
      '1'..'9': GetDup;
      '"'     : GetSpeak;
     end;
    end else
     Dec(PatDup);
    case Pattern[PatPos] of
     'u':dy:=-4;
     'd':dy:=+4;
     'l':dx:=-4;
     'r':dx:=+4;
    end;
   end else begin
    dx:=random(64); dec(dx,32);
    dy:=random(64); dec(dy,32);
   end;
  end;
  MoveSprite;
 end;

procedure TCharacter.MoveSprite;
 begin
  if (dx=0) and (dy=0) then walk:=0 else walk:=succ(walk) and 3;

  if dy>0 then begin
   if moveit(0,+Step) then dec(dy) else dy:=0;
   direct:=0;
  end;

  if dy<0 then begin
   if moveit(0,-Step) then inc(dy) else dy:=0;
   direct:=2;
  end;

  if dx>0 then begin
   if moveit(+Step,0) then dec(dx) else dx:=0;
   direct:=3;
  end;

  if dx<0 then begin
   if moveit(-Step,0) then inc(dx) else dx:=0;
   direct:=1;
  end;

 end;

Function TCharacter.MoveIt(ix,iy:integer):boolean;
 var
  tx,ty,x1,y1,x2,y2:integer;
 begin
  moveit:=true;

  tx:=cx+ix;
  if tx<0 then begin { leave left }
   dec(wx,13);
   inc(cx,12*16);
   exit;
  end;

  x1:=(tx) div 16;
  x2:=(tx+15) div 16;
  if x2>12 then begin { leave right  }
   inc(wx,13);
   dec(cx,12*16);
   exit;
  end;

  ty:=cy+iy;
  if ty<0 then begin { leave up }
   dec(wy,11);
   inc(cy,10*16);
   exit;
  end;

  y1:=(ty+8) div 16;
  y2:=(ty+15) div 16;
  if y2>10 then begin { leave down }
   inc(wy,11);
   dec(cy,10*16);
   exit;
  end;

  moveit:=false;      { can't move }

  if world^[wy+y1,wx+x1]>=10 then exit;
  if world^[wy+y1,wx+x2]>=10 then exit;
  if world^[wy+y2,wx+x1]>=10 then exit;
  if world^[wy+y2,wx+x2]>=10 then exit;

  moveit:=true;      { ok to move }

  inc(cx,ix);
  inc(cy,iy);
 end;

end.